#
# Copyright 2021 DataRobot, Inc. and its affiliates.
#
# All rights reserved.
#
# DataRobot, Inc.
#
# This is proprietary source code of DataRobot, Inc. and its
# affiliates.
#
# Released under the terms of DataRobot Tool and Utility Agreement.
"""
Autogenerated DataRobot python client file.  Please don't modify.
"""

import trafaret as t
from datarobot.models.api_object import APIObject

class AccountLimits(APIObject):
    """
    Attributes
    ----------
    max_upload_size:int [optional]
         Maximum size for file uploads (MB). 
    max_upload_size_catalog:int [optional]
         Maximum size for catalog file uploads (MB). 
    """
    _converter = t.Dict(
        {
            t.Key("max_upload_size", optional=True):  t.Int(),
            t.Key("max_upload_size_catalog", optional=True):  t.Int(),
        }
    ).ignore_extra("*")

    def __init__(
        self,
        max_upload_size=None,
        max_upload_size_catalog=None,
    ):
        self.max_upload_size = max_upload_size
        self.max_upload_size_catalog = max_upload_size_catalog

    def __repr__(self):
        return (
            "AccountLimits("
            "max_upload_size={0.max_upload_size}, "
            "max_upload_size_catalog={0.max_upload_size_catalog}, "
        ).format(self)
