#
# Copyright 2021 DataRobot, Inc. and its affiliates.
#
# All rights reserved.
#
# DataRobot, Inc.
#
# This is proprietary source code of DataRobot, Inc. and its
# affiliates.
#
# Released under the terms of DataRobot Tool and Utility Agreement.
"""
Autogenerated DataRobot python client file.  Please don't modify.
"""

import trafaret as t
from datarobot.models.api_object import APIObject

class ActivationMapsComputeResponse(APIObject):
    """
    Attributes
    ----------
    id:str
         The job ID.
    is_blocked:bool
         True if the job is waiting for its dependencies to be resolved first.
    job_type:str
         the type of the job. defaults to "compute_image_activation_maps", must be one of ["compute_image_activation_maps", ]
    model_id:str
         the model ID of the target model
    project_id:str
         The project the job belongs to.
    status:str
         The job status.
    url:str
         A URL that can be used to request details about the job.
    """
    _converter = t.Dict(
        {
            t.Key("id"):  t.String(),
            t.Key("is_blocked"):  t.Bool(),
            t.Key("job_type"):  t.String(),
            t.Key("model_id"):  t.String(),
            t.Key("project_id"):  t.String(),
            t.Key("status"):  t.String(),
            t.Key("url"):  t.String(),
        }
    ).ignore_extra("*")

    def __init__(
        self,
        id,
        is_blocked,
        job_type,
        model_id,
        project_id,
        status,
        url,
    ):
        self.id = id
        self.is_blocked = is_blocked
        self.job_type = job_type
        self.model_id = model_id
        self.project_id = project_id
        self.status = status
        self.url = url

    def __repr__(self):
        return (
            "ActivationMapsComputeResponse("
            "id={0.id}, "
            "is_blocked={0.is_blocked}, "
            "job_type={0.job_type}, "
            "model_id={0.model_id}, "
            "project_id={0.project_id}, "
            "status={0.status}, "
            "url={0.url}, "
        ).format(self)
