#
# Copyright 2021 DataRobot, Inc. and its affiliates.
#
# All rights reserved.
#
# DataRobot, Inc.
#
# This is proprietary source code of DataRobot, Inc. and its
# affiliates.
#
# Released under the terms of DataRobot Tool and Utility Agreement.
"""
Autogenerated DataRobot python client file.  Please don't modify.
"""

import trafaret as t
from datarobot.models.api_object import APIObject

class AOTChartStatistics(APIObject):
    """
    Attributes
    ----------
    durbin_watson:float
         The Durbin-Watson statistic for the chart data. Value is between 0 and 4. Returns -1 when the statistic is invalid for the data, e.g. if this is an anomaly detection project.
    """
    _converter = t.Dict(
        {
            t.Key("durbin_watson"):  t.Float(),
        }
    ).ignore_extra("*")

    def __init__(
        self,
        durbin_watson,
    ):
        self.durbin_watson = durbin_watson

    def __repr__(self):
        return (
            "AOTChartStatistics("
            "durbin_watson={0.durbin_watson}, "
        ).format(self)
