#
# Copyright 2021 DataRobot, Inc. and its affiliates.
#
# All rights reserved.
#
# DataRobot, Inc.
#
# This is proprietary source code of DataRobot, Inc. and its
# affiliates.
#
# Released under the terms of DataRobot Tool and Utility Agreement.
"""
Autogenerated DataRobot python client file.  Please don't modify.
"""

import trafaret as t
from datarobot.models.api_object import APIObject

class ApplicationCreateSources(APIObject):
    """
    Attributes
    ----------
    info:bool, date, datetime, dict, float, int, list, str, none_type
         Information about the Deployment or Dataset source.
    source:str
         Information about the source for this application.
    name:str [optional]
         The name of this source.. 
    """
    _converter = t.Dict(
        {
            t.Key("info"):  t.Any(),
            t.Key("source"):  t.String(),
            t.Key("name", optional=True):  t.String(),
        }
    ).ignore_extra("*")

    def __init__(
        self,
        info,
        source,
        name=None,
    ):
        self.info = info
        self.source = source
        self.name = name

    def __repr__(self):
        return (
            "ApplicationCreateSources("
            "info={0.info}, "
            "source={0.source}, "
            "name={0.name}, "
        ).format(self)
