#
# Copyright 2021 DataRobot, Inc. and its affiliates.
#
# All rights reserved.
#
# DataRobot, Inc.
#
# This is proprietary source code of DataRobot, Inc. and its
# affiliates.
#
# Released under the terms of DataRobot Tool and Utility Agreement.
"""
Autogenerated DataRobot python client file.  Please don't modify.
"""

import trafaret as t
from datarobot.models.api_object import APIObject

class ApplicationDeploymentUpdate(APIObject):
    """
    Attributes
    ----------
    description:str [optional]
         The description of the application's deployment. 
    domain:str, none_type [optional]
         The new domain prefix for the app. 
    name:str [optional]
         The name of the new app. 
    """
    _converter = t.Dict(
        {
            t.Key("description", optional=True):  t.String(),
            t.Key("domain", optional=True):  t.String(),
            t.Key("name", optional=True):  t.String(),
        }
    ).ignore_extra("*")

    def __init__(
        self,
        description=None,
        domain=None,
        name=None,
    ):
        self.description = description
        self.domain = domain
        self.name = name

    def __repr__(self):
        return (
            "ApplicationDeploymentUpdate("
            "description={0.description}, "
            "domain={0.domain}, "
            "name={0.name}, "
        ).format(self)
