#
# Copyright 2021 DataRobot, Inc. and its affiliates.
#
# All rights reserved.
#
# DataRobot, Inc.
#
# This is proprietary source code of DataRobot, Inc. and its
# affiliates.
#
# Released under the terms of DataRobot Tool and Utility Agreement.
"""
Autogenerated DataRobot python client file.  Please don't modify.
"""

import trafaret as t
from datarobot.models.api_object import APIObject

class BacktestOldMethodForOpenApi(APIObject):
    """
    Attributes
    ----------
    gap_duration:str
         A duration string representing the duration of the gap between the training and the validation data for this backtest.
    index:int
         The index from zero of the backtest.
    validation_duration:str
         A duration string representing the duration of the validation data for this backtest.
    validation_start_date:datetime
         A datetime string representing the start date of the validation data for this backtest.
    """
    _converter = t.Dict(
        {
            t.Key("gap_duration"):  t.String(),
            t.Key("index"):  t.Int(),
            t.Key("validation_duration"):  t.String(),
            t.Key("validation_start_date"):  t.DateTime(),
        }
    ).ignore_extra("*")

    def __init__(
        self,
        gap_duration,
        index,
        validation_duration,
        validation_start_date,
    ):
        self.gap_duration = gap_duration
        self.index = index
        self.validation_duration = validation_duration
        self.validation_start_date = validation_start_date

    def __repr__(self):
        return (
            "BacktestOldMethodForOpenApi("
            "gap_duration={0.gap_duration}, "
            "index={0.index}, "
            "validation_duration={0.validation_duration}, "
            "validation_start_date={0.validation_start_date}, "
        ).format(self)
