#
# Copyright 2021 DataRobot, Inc. and its affiliates.
#
# All rights reserved.
#
# DataRobot, Inc.
#
# This is proprietary source code of DataRobot, Inc. and its
# affiliates.
#
# Released under the terms of DataRobot Tool and Utility Agreement.
"""
Autogenerated DataRobot python client file.  Please don't modify.
"""

import trafaret as t
from datarobot.models.api_object import APIObject

class Backtests(APIObject):
    """
    Attributes
    ----------
    validation_end_date:datetime
         The end date of the validation scoring data for this backtest.
    validation_start_date:datetime
         The start date of the validation scoring data for this backtest.
    """
    _converter = t.Dict(
        {
            t.Key("validation_end_date"):  t.DateTime(),
            t.Key("validation_start_date"):  t.DateTime(),
        }
    ).ignore_extra("*")

    def __init__(
        self,
        validation_end_date,
        validation_start_date,
    ):
        self.validation_end_date = validation_end_date
        self.validation_start_date = validation_start_date

    def __repr__(self):
        return (
            "Backtests("
            "validation_end_date={0.validation_end_date}, "
            "validation_start_date={0.validation_start_date}, "
        ).format(self)
