#
# Copyright 2021 DataRobot, Inc. and its affiliates.
#
# All rights reserved.
#
# DataRobot, Inc.
#
# This is proprietary source code of DataRobot, Inc. and its
# affiliates.
#
# Released under the terms of DataRobot Tool and Utility Agreement.
"""
Autogenerated DataRobot python client file.  Please don't modify.
"""

import trafaret as t
from datarobot.models.api_object import APIObject

class BatchFeatureTransformRetrieveResponse(APIObject):
    """
    Attributes
    ----------
    failures:{str: (bool, date, datetime, dict, float, int, list, str, none_type)}
         An object keyed by original feature names, the values are strings indicating why the transformation failed.
    new_feature_names:[str]
         List of new feature names.
    """
    _converter = t.Dict(
        {
            t.Key("failures"):  t.Any(),
            t.Key("new_feature_names"):  t.List(t.Dict().allow_extra("*")),
        }
    ).ignore_extra("*")

    def __init__(
        self,
        failures,
        new_feature_names,
    ):
        self.failures = failures
        self.new_feature_names = new_feature_names

    def __repr__(self):
        return (
            "BatchFeatureTransformRetrieveResponse("
            "failures={0.failures}, "
            "new_feature_names={0.new_feature_names}, "
        ).format(self)
