#
# Copyright 2021 DataRobot, Inc. and its affiliates.
#
# All rights reserved.
#
# DataRobot, Inc.
#
# This is proprietary source code of DataRobot, Inc. and its
# affiliates.
#
# Released under the terms of DataRobot Tool and Utility Agreement.
"""
Autogenerated DataRobot python client file.  Please don't modify.
"""

import trafaret as t
from datarobot.models.api_object import APIObject

class BatchPredictionJobLinks(APIObject):
    """
    Attributes
    ----------
    _self:str
         The URL used access this job.
    csv_upload:str [optional]
         The URL used to upload the dataset for this job. Only available for localFile intake.. 
    download:str, none_type [optional]
         The URL used to download the results from this job. Only available for localFile outputs. Will be null if the download is not yet available.. 
    """
    _converter = t.Dict(
        {
            t.Key("_self"):  t.String(),
            t.Key("csv_upload", optional=True):  t.String(),
            t.Key("download", optional=True):  t.String(),
        }
    ).ignore_extra("*")

    def __init__(
        self,
        _self,
        csv_upload=None,
        download=None,
    ):
        self._self = _self
        self.csv_upload = csv_upload
        self.download = download

    def __repr__(self):
        return (
            "BatchPredictionJobLinks("
            "_self={0._self}, "
            "csv_upload={0.csv_upload}, "
            "download={0.download}, "
        ).format(self)
