#
# Copyright 2021 DataRobot, Inc. and its affiliates.
#
# All rights reserved.
#
# DataRobot, Inc.
#
# This is proprietary source code of DataRobot, Inc. and its
# affiliates.
#
# Released under the terms of DataRobot Tool and Utility Agreement.
"""
Autogenerated DataRobot python client file.  Please don't modify.
"""

import trafaret as t
from datarobot.models.api_object import APIObject

class BlueprintDocParameters(APIObject):
    """
    Attributes
    ----------
    description:str
         A description of what the parameter does.
    name:str
         The name of the parameter.
    type:str
         The type (and default value) of the parameter.
    """
    _converter = t.Dict(
        {
            t.Key("description"):  t.String(),
            t.Key("name"):  t.String(),
            t.Key("type"):  t.String(),
        }
    ).ignore_extra("*")

    def __init__(
        self,
        description,
        name,
        type,
    ):
        self.description = description
        self.name = name
        self.type = type

    def __repr__(self):
        return (
            "BlueprintDocParameters("
            "description={0.description}, "
            "name={0.name}, "
            "type={0.type}, "
        ).format(self)
