#
# Copyright 2021 DataRobot, Inc. and its affiliates.
#
# All rights reserved.
#
# DataRobot, Inc.
#
# This is proprietary source code of DataRobot, Inc. and its
# affiliates.
#
# Released under the terms of DataRobot Tool and Utility Agreement.
"""
Autogenerated DataRobot python client file.  Please don't modify.
"""

import trafaret as t
from datarobot.models.api_object import APIObject

class ComplianceDocTemplateDefaultRetrieveResponse(APIObject):
    """
    Attributes
    ----------
    sections:[bool, date, datetime, dict, float, int, list, str, none_type]
         List of section objects representing the structure of the document. Each section can have sub-sections that have the same schema as the parent section, i.e., the structure is recursive. The number of nested sections allowed is 5. The total number of sections allowed is 500. 
    """
    _converter = t.Dict(
        {
            t.Key("sections"):  t.List(t.Dict().allow_extra("*")),
        }
    ).ignore_extra("*")

    def __init__(
        self,
        sections,
    ):
        self.sections = sections

    def __repr__(self):
        return (
            "ComplianceDocTemplateDefaultRetrieveResponse("
            "sections={0.sections}, "
        ).format(self)
