#
# Copyright 2021 DataRobot, Inc. and its affiliates.
#
# All rights reserved.
#
# DataRobot, Inc.
#
# This is proprietary source code of DataRobot, Inc. and its
# affiliates.
#
# Released under the terms of DataRobot Tool and Utility Agreement.
"""
Autogenerated DataRobot python client file.  Please don't modify.
"""

import trafaret as t
from datarobot.models.api_object import APIObject

class CredentialsBodyOneOf6(APIObject):
    """
    Attributes
    ----------
    credential_type:str
         Credentials type.. defaults to "adls_gen2_oauth", must be one of ["adls_gen2_oauth", ]
    name:str
         Credentials name.
    description:str [optional]
         Credentials description.. 
    """
    _converter = t.Dict(
        {
            t.Key("credential_type"):  t.String(),
            t.Key("name"):  t.String(),
            t.Key("description", optional=True):  t.String(),
        }
    ).ignore_extra("*")

    def __init__(
        self,
        credential_type,
        name,
        description=None,
    ):
        self.credential_type = credential_type
        self.name = name
        self.description = description

    def __repr__(self):
        return (
            "CredentialsBodyOneOf6("
            "credential_type={0.credential_type}, "
            "name={0.name}, "
            "description={0.description}, "
        ).format(self)
