#
# Copyright 2021 DataRobot, Inc. and its affiliates.
#
# All rights reserved.
#
# DataRobot, Inc.
#
# This is proprietary source code of DataRobot, Inc. and its
# affiliates.
#
# Released under the terms of DataRobot Tool and Utility Agreement.
"""
Autogenerated DataRobot python client file.  Please don't modify.
"""

import trafaret as t
from datarobot.models.api_object import APIObject

class CrossSeriesGroupByColumnsListItem(APIObject):
    """
    Attributes
    ----------
    eligibility:str
         Information about the column's eligibility. If the column is not eligible, this will include the reason why.
    is_eligible:bool
         Indicates whether this column can be used as a group-by column.
    name:str
         The name of the column.
    """
    _converter = t.Dict(
        {
            t.Key("eligibility"):  t.String(),
            t.Key("is_eligible"):  t.Bool(),
            t.Key("name"):  t.String(),
        }
    ).ignore_extra("*")

    def __init__(
        self,
        eligibility,
        is_eligible,
        name,
    ):
        self.eligibility = eligibility
        self.is_eligible = is_eligible
        self.name = name

    def __repr__(self):
        return (
            "CrossSeriesGroupByColumnsListItem("
            "eligibility={0.eligibility}, "
            "is_eligible={0.is_eligible}, "
            "name={0.name}, "
        ).format(self)
