#
# Copyright 2021 DataRobot, Inc. and its affiliates.
#
# All rights reserved.
#
# DataRobot, Inc.
#
# This is proprietary source code of DataRobot, Inc. and its
# affiliates.
#
# Released under the terms of DataRobot Tool and Utility Agreement.
"""
Autogenerated DataRobot python client file.  Please don't modify.
"""

import trafaret as t
from datarobot.models.api_object import APIObject

class CustomBoundaries(APIObject):
    """
    Attributes
    ----------
    lower:float
         All predictions less than provided value are considered anomalous.
    upper:float
         All predictions greater than provided value are considered anomalous.
    """
    _converter = t.Dict(
        {
            t.Key("lower"):  t.Float(),
            t.Key("upper"):  t.Float(),
        }
    ).ignore_extra("*")

    def __init__(
        self,
        lower,
        upper,
    ):
        self.lower = lower
        self.upper = upper

    def __repr__(self):
        return (
            "CustomBoundaries("
            "lower={0.lower}, "
            "upper={0.upper}, "
        ).format(self)
