#
# Copyright 2021 DataRobot, Inc. and its affiliates.
#
# All rights reserved.
#
# DataRobot, Inc.
#
# This is proprietary source code of DataRobot, Inc. and its
# affiliates.
#
# Released under the terms of DataRobot Tool and Utility Agreement.
"""
Autogenerated DataRobot python client file.  Please don't modify.
"""

import trafaret as t
from datarobot.models.api_object import APIObject
from datarobot.models.full_api.generated.model.custom_model_performance_check_parameters import CustomModelPerformanceCheckParameters
from datarobot.models.full_api.generated.model.custom_model_pred_verification_check_parameters import CustomModelPredVerificationCheckParameters
from datarobot.models.full_api.generated.model.custom_model_stability_check_parameters import CustomModelStabilityCheckParameters

class CustomModelTestsParameters(APIObject):
    """
    Attributes
    ----------
    performance_check:CustomModelPerformanceCheckParameters [optional]
         
    prediction_verification_check:CustomModelPredVerificationCheckParameters [optional]
         
    stability_check:CustomModelStabilityCheckParameters [optional]
         
    """
    _converter = t.Dict(
        {
            t.Key("performance_check", optional=True):  t.Any(),
            t.Key("prediction_verification_check", optional=True):  t.Any(),
            t.Key("stability_check", optional=True):  t.Any(),
        }
    ).ignore_extra("*")

    def __init__(
        self,
        performance_check=None,
        prediction_verification_check=None,
        stability_check=None,
    ):
        self.performance_check = performance_check
        self.prediction_verification_check = prediction_verification_check
        self.stability_check = stability_check

    def __repr__(self):
        return (
            "CustomModelTestsParameters("
            "performance_check={0.performance_check}, "
            "prediction_verification_check={0.prediction_verification_check}, "
            "stability_check={0.stability_check}, "
        ).format(self)
