#
# Copyright 2021 DataRobot, Inc. and its affiliates.
#
# All rights reserved.
#
# DataRobot, Inc.
#
# This is proprietary source code of DataRobot, Inc. and its
# affiliates.
#
# Released under the terms of DataRobot Tool and Utility Agreement.
"""
Autogenerated DataRobot python client file.  Please don't modify.
"""

import trafaret as t
from datarobot.models.api_object import APIObject

class DataSourceCreate(APIObject):
    """
    Attributes
    ----------
    canonical_name:str
         Data source canonical name.
    params:bool, date, datetime, dict, float, int, list, str, none_type
         Data source configuration.
    type:str
         Data source type.
    """
    _converter = t.Dict(
        {
            t.Key("canonical_name"):  t.String(),
            t.Key("params"):  t.Any(),
            t.Key("type"):  t.String(),
        }
    ).ignore_extra("*")

    def __init__(
        self,
        canonical_name,
        params,
        type,
    ):
        self.canonical_name = canonical_name
        self.params = params
        self.type = type

    def __repr__(self):
        return (
            "DataSourceCreate("
            "canonical_name={0.canonical_name}, "
            "params={0.params}, "
            "type={0.type}, "
        ).format(self)
