#
# Copyright 2021 DataRobot, Inc. and its affiliates.
#
# All rights reserved.
#
# DataRobot, Inc.
#
# This is proprietary source code of DataRobot, Inc. and its
# affiliates.
#
# Released under the terms of DataRobot Tool and Utility Agreement.
"""
Autogenerated DataRobot python client file.  Please don't modify.
"""

import trafaret as t
from datarobot.models.api_object import APIObject

class DeletedDeploymentResponse(APIObject):
    """
    Attributes
    ----------
    deleted_at:datetime
         The date and time of when the deployment was deleted, in ISO 8601 format.
    id:str
         ID of the deployment.
    label:str
         Label of the deployment.
    """
    _converter = t.Dict(
        {
            t.Key("deleted_at"):  t.DateTime(),
            t.Key("id"):  t.String(),
            t.Key("label"):  t.String(),
        }
    ).ignore_extra("*")

    def __init__(
        self,
        deleted_at,
        id,
        label,
    ):
        self.deleted_at = deleted_at
        self.id = id
        self.label = label

    def __repr__(self):
        return (
            "DeletedDeploymentResponse("
            "deleted_at={0.deleted_at}, "
            "id={0.id}, "
            "label={0.label}, "
        ).format(self)
