#
# Copyright 2021 DataRobot, Inc. and its affiliates.
#
# All rights reserved.
#
# DataRobot, Inc.
#
# This is proprietary source code of DataRobot, Inc. and its
# affiliates.
#
# Released under the terms of DataRobot Tool and Utility Agreement.
"""
Autogenerated DataRobot python client file.  Please don't modify.
"""

import trafaret as t
from datarobot.models.api_object import APIObject

class DeploymentUpdate(APIObject):
    """
    Attributes
    ----------
    description:str, none_type [optional]
         A description for the deployment.. 
    importance:str [optional]
         Shows how important this deployment is.. 
    label:str, none_type [optional]
         A human-readable name for the deployment.. 
    """
    _converter = t.Dict(
        {
            t.Key("description", optional=True):  t.String(),
            t.Key("importance", optional=True):  t.String(),
            t.Key("label", optional=True):  t.String(),
        }
    ).ignore_extra("*")

    def __init__(
        self,
        description=None,
        importance=None,
        label=None,
    ):
        self.description = description
        self.importance = importance
        self.label = label

    def __repr__(self):
        return (
            "DeploymentUpdate("
            "description={0.description}, "
            "importance={0.importance}, "
            "label={0.label}, "
        ).format(self)
