#
# Copyright 2021 DataRobot, Inc. and its affiliates.
#
# All rights reserved.
#
# DataRobot, Inc.
#
# This is proprietary source code of DataRobot, Inc. and its
# affiliates.
#
# Released under the terms of DataRobot Tool and Utility Agreement.
"""
Autogenerated DataRobot python client file.  Please don't modify.
"""

import trafaret as t
from datarobot.models.api_object import APIObject
from datarobot.models.full_api.generated.model.event_type import EventType

class EventGroup(APIObject):
    """
    Attributes
    ----------
    events:[EventType]
         The events included in this group.
    id:str
         The id of the event group.
    label:str
         The display name of the event group.
    """
    _converter = t.Dict(
        {
            t.Key("events"):  t.List(t.Dict().allow_extra("*")),
            t.Key("id"):  t.String(),
            t.Key("label"):  t.String(),
        }
    ).ignore_extra("*")

    def __init__(
        self,
        events,
        id,
        label,
    ):
        self.events = events
        self.id = id
        self.label = label

    def __repr__(self):
        return (
            "EventGroup("
            "events={0.events}, "
            "id={0.id}, "
            "label={0.label}, "
        ).format(self)
