#
# Copyright 2021 DataRobot, Inc. and its affiliates.
#
# All rights reserved.
#
# DataRobot, Inc.
#
# This is proprietary source code of DataRobot, Inc. and its
# affiliates.
#
# Released under the terms of DataRobot Tool and Utility Agreement.
"""
Autogenerated DataRobot python client file.  Please don't modify.
"""

import trafaret as t
from datarobot.models.api_object import APIObject

class FeatureEffectsCreateDatetime(APIObject):
    """
    Attributes
    ----------
    backtest_index:str
         The backtest index. For example: `0`, `1`, ..., `20`, `holdout`, `startstop`.
    row_count:int, none_type [optional]
         The number of rows from dataset to use for Feature Impact calculation.. 
    """
    _converter = t.Dict(
        {
            t.Key("backtest_index"):  t.String(),
            t.Key("row_count", optional=True):  t.Int(),
        }
    ).ignore_extra("*")

    def __init__(
        self,
        backtest_index,
        row_count=None,
    ):
        self.backtest_index = backtest_index
        self.row_count = row_count

    def __repr__(self):
        return (
            "FeatureEffectsCreateDatetime("
            "backtest_index={0.backtest_index}, "
            "row_count={0.row_count}, "
        ).format(self)
