#
# Copyright 2021 DataRobot, Inc. and its affiliates.
#
# All rights reserved.
#
# DataRobot, Inc.
#
# This is proprietary source code of DataRobot, Inc. and its
# affiliates.
#
# Released under the terms of DataRobot Tool and Utility Agreement.
"""
Autogenerated DataRobot python client file.  Please don't modify.
"""

import trafaret as t
from datarobot.models.api_object import APIObject

class GrantAccessControlWithIdWithGrant(APIObject):
    """
    Attributes
    ----------
    id:str
         The ID of the recipient.
    role:str
         The role of the recipient on this entity. One of OWNER, USER, OBSERVER.
    share_recipient_type:str
         Describes the recipient type, either user, group, or organization.
    can_share:bool [optional]
         Whether the org/group/user should be able to share with others.If true, the org/group/user will be able to grant any role up to and includingtheir own to other orgs/groups/user. If `role` is `NO_ROLE` `canShare` is ignored..  if omitted the server will use the default value of True
    """
    _converter = t.Dict(
        {
            t.Key("id"):  t.String(),
            t.Key("role"):  t.String(),
            t.Key("share_recipient_type"):  t.String(),
            t.Key("can_share", optional=True):  t.Bool(),
        }
    ).ignore_extra("*")

    def __init__(
        self,
        id,
        role,
        share_recipient_type,
        can_share=None,
    ):
        self.id = id
        self.role = role
        self.share_recipient_type = share_recipient_type
        self.can_share = can_share

    def __repr__(self):
        return (
            "GrantAccessControlWithIdWithGrant("
            "id={0.id}, "
            "role={0.role}, "
            "share_recipient_type={0.share_recipient_type}, "
            "can_share={0.can_share}, "
        ).format(self)
