#
# Copyright 2021 DataRobot, Inc. and its affiliates.
#
# All rights reserved.
#
# DataRobot, Inc.
#
# This is proprietary source code of DataRobot, Inc. and its
# affiliates.
#
# Released under the terms of DataRobot Tool and Utility Agreement.
"""
Autogenerated DataRobot python client file.  Please don't modify.
"""

import trafaret as t
from datarobot.models.api_object import APIObject

class ModelFeatureListResponse(APIObject):
    """
    Attributes
    ----------
    a_priori_feature_names:[str]
         (Deprecated in version v2.11) Renamed to `knownInAdvanceFeatureNames`. This parameter always has the same value as `knownInAdvanceFeatureNames` and will be removed in a future release.
    feature_names:[str]
         An array of the names of all features used by the specified model.
    known_in_advance_feature_names:[str]
         An array of the names of time series known-in-advance features used by the specified model.
    """
    _converter = t.Dict(
        {
            t.Key("a_priori_feature_names"):  t.List(t.Dict().allow_extra("*")),
            t.Key("feature_names"):  t.List(t.Dict().allow_extra("*")),
            t.Key("known_in_advance_feature_names"):  t.List(t.Dict().allow_extra("*")),
        }
    ).ignore_extra("*")

    def __init__(
        self,
        a_priori_feature_names,
        feature_names,
        known_in_advance_feature_names,
    ):
        self.a_priori_feature_names = a_priori_feature_names
        self.feature_names = feature_names
        self.known_in_advance_feature_names = known_in_advance_feature_names

    def __repr__(self):
        return (
            "ModelFeatureListResponse("
            "a_priori_feature_names={0.a_priori_feature_names}, "
            "feature_names={0.feature_names}, "
            "known_in_advance_feature_names={0.known_in_advance_feature_names}, "
        ).format(self)
