#
# Copyright 2021 DataRobot, Inc. and its affiliates.
#
# All rights reserved.
#
# DataRobot, Inc.
#
# This is proprietary source code of DataRobot, Inc. and its
# affiliates.
#
# Released under the terms of DataRobot Tool and Utility Agreement.
"""
Autogenerated DataRobot python client file.  Please don't modify.
"""

import trafaret as t
from datarobot.models.api_object import APIObject

class ModelXrayMetadataDatetimeDataResponse(APIObject):
    """
    Attributes
    ----------
    backtest_index:str
         The backtest index. For example: `0`, `1`, ..., `20`, `holdout`, `startstop`.
    sources:[str]
         List of sources available for the model.
    status:str
         Status of the job
    """
    _converter = t.Dict(
        {
            t.Key("backtest_index"):  t.String(),
            t.Key("sources"):  t.List(t.Dict().allow_extra("*")),
            t.Key("status"):  t.String(),
        }
    ).ignore_extra("*")

    def __init__(
        self,
        backtest_index,
        sources,
        status,
    ):
        self.backtest_index = backtest_index
        self.sources = sources
        self.status = status

    def __repr__(self):
        return (
            "ModelXrayMetadataDatetimeDataResponse("
            "backtest_index={0.backtest_index}, "
            "sources={0.sources}, "
            "status={0.status}, "
        ).format(self)
