#
# Copyright 2021 DataRobot, Inc. and its affiliates.
#
# All rights reserved.
#
# DataRobot, Inc.
#
# This is proprietary source code of DataRobot, Inc. and its
# affiliates.
#
# Released under the terms of DataRobot Tool and Utility Agreement.
"""
Autogenerated DataRobot python client file.  Please don't modify.
"""

import trafaret as t
from datarobot.models.api_object import APIObject
from datarobot.models.full_api.generated.model.lift_chartbins import LiftChartbins

class MulticlassLiftDataClassBins(APIObject):
    """
    Attributes
    ----------
    bins:[LiftChartbins]
         The lift chart data for that source and class, as specified below.
    target_class:str
         The target class for the lift chart.
    """
    _converter = t.Dict(
        {
            t.Key("bins"):  t.List(t.Dict().allow_extra("*")),
            t.Key("target_class"):  t.String(),
        }
    ).ignore_extra("*")

    def __init__(
        self,
        bins,
        target_class,
    ):
        self.bins = bins
        self.target_class = target_class

    def __repr__(self):
        return (
            "MulticlassLiftDataClassBins("
            "bins={0.bins}, "
            "target_class={0.target_class}, "
        ).format(self)
