#
# Copyright 2021 DataRobot, Inc. and its affiliates.
#
# All rights reserved.
#
# DataRobot, Inc.
#
# This is proprietary source code of DataRobot, Inc. and its
# affiliates.
#
# Released under the terms of DataRobot Tool and Utility Agreement.
"""
Autogenerated DataRobot python client file.  Please don't modify.
"""

import trafaret as t
from datarobot.models.api_object import APIObject
from datarobot.models.full_api.generated.model.notification_policy_mute_response import NotificationPolicyMuteResponse

class NotificationPolicyMuteListResponse(APIObject):
    """
    Attributes
    ----------
    count:int
         The number of items returned on this page
    data:[NotificationPolicyMuteResponse]
         A list of Notification Policy Mutes
    next:str, none_type
         URL pointing to the next page (if null, there is no next page)
    previous:str, none_type
         URL pointing to the previous page (if null, there is no previous page)
    total_count:int
         The total number of items returned by the query
    """
    _converter = t.Dict(
        {
            t.Key("count"):  t.Int(),
            t.Key("data"):  t.List(t.Dict().allow_extra("*")),
            t.Key("next"):  t.String(),
            t.Key("previous"):  t.String(),
            t.Key("total_count"):  t.Int(),
        }
    ).ignore_extra("*")

    def __init__(
        self,
        count,
        data,
        next,
        previous,
        total_count,
    ):
        self.count = count
        self.data = data
        self.next = next
        self.previous = previous
        self.total_count = total_count

    def __repr__(self):
        return (
            "NotificationPolicyMuteListResponse("
            "count={0.count}, "
            "data={0.data}, "
            "next={0.next}, "
            "previous={0.previous}, "
            "total_count={0.total_count}, "
        ).format(self)
