#
# Copyright 2021 DataRobot, Inc. and its affiliates.
#
# All rights reserved.
#
# DataRobot, Inc.
#
# This is proprietary source code of DataRobot, Inc. and its
# affiliates.
#
# Released under the terms of DataRobot Tool and Utility Agreement.
"""
Autogenerated DataRobot python client file.  Please don't modify.
"""

import trafaret as t
from datarobot.models.api_object import APIObject

class NotifyStatus(APIObject):
    """
    Attributes
    ----------
    sent_status:bool
         Boolean value whether an invite has been sent to the user or not.
    invite_link:str [optional]
         The link the user can follow to complete their DR account.. 
    """
    _converter = t.Dict(
        {
            t.Key("sent_status"):  t.Bool(),
            t.Key("invite_link", optional=True):  t.String(),
        }
    ).ignore_extra("*")

    def __init__(
        self,
        sent_status,
        invite_link=None,
    ):
        self.sent_status = sent_status
        self.invite_link = invite_link

    def __repr__(self):
        return (
            "NotifyStatus("
            "sent_status={0.sent_status}, "
            "invite_link={0.invite_link}, "
        ).format(self)
