#
# Copyright 2021 DataRobot, Inc. and its affiliates.
#
# All rights reserved.
#
# DataRobot, Inc.
#
# This is proprietary source code of DataRobot, Inc. and its
# affiliates.
#
# Released under the terms of DataRobot Tool and Utility Agreement.
"""
Autogenerated DataRobot python client file.  Please don't modify.
"""

import trafaret as t
from datarobot.models.api_object import APIObject

class OptionalDRConnectorV1DataSource(APIObject):
    """
    Attributes
    ----------
    data_store_id:str [optional]
         Data store ID for this data source.. 
    path:str [optional]
         Path to the dataset within whatever filesystem data source is using. For example, for S3 the path will look something like `/foldername/filename.csv`.. 
    """
    _converter = t.Dict(
        {
            t.Key("data_store_id", optional=True):  t.String(),
            t.Key("path", optional=True):  t.String(),
        }
    ).ignore_extra("*")

    def __init__(
        self,
        data_store_id=None,
        path=None,
    ):
        self.data_store_id = data_store_id
        self.path = path

    def __repr__(self):
        return (
            "OptionalDRConnectorV1DataSource("
            "data_store_id={0.data_store_id}, "
            "path={0.path}, "
        ).format(self)
