#
# Copyright 2021 DataRobot, Inc. and its affiliates.
#
# All rights reserved.
#
# DataRobot, Inc.
#
# This is proprietary source code of DataRobot, Inc. and its
# affiliates.
#
# Released under the terms of DataRobot Tool and Utility Agreement.
"""
Autogenerated DataRobot python client file.  Please don't modify.
"""

import trafaret as t
from datarobot.models.api_object import APIObject
from datarobot.models.full_api.generated.model.partial_dependence_data import PartialDependenceData

class PartialDependence(APIObject):
    """
    Attributes
    ----------
    data:[PartialDependenceData]
         Partial dependence results.
    is_capped:bool
         Indicates whether the data for computation is capped.
    """
    _converter = t.Dict(
        {
            t.Key("data"):  t.List(t.Dict().allow_extra("*")),
            t.Key("is_capped"):  t.Bool(),
        }
    ).ignore_extra("*")

    def __init__(
        self,
        data,
        is_capped,
    ):
        self.data = data
        self.is_capped = is_capped

    def __repr__(self):
        return (
            "PartialDependence("
            "data={0.data}, "
            "is_capped={0.is_capped}, "
        ).format(self)
