#
# Copyright 2021 DataRobot, Inc. and its affiliates.
#
# All rights reserved.
#
# DataRobot, Inc.
#
# This is proprietary source code of DataRobot, Inc. and its
# affiliates.
#
# Released under the terms of DataRobot Tool and Utility Agreement.
"""
Autogenerated DataRobot python client file.  Please don't modify.
"""

import trafaret as t
from datarobot.models.api_object import APIObject

class PasswordCredentials(APIObject):
    """
    Attributes
    ----------
    password:str
         The password (in cleartext) for database authentication. The password will be encrypted on the server side in scope of HTTP request and never saved or stored.
    user:str
         The username for database authentication.
    catalog_version_id:str [optional]
         The ID of the latest version of the catalog entry.. 
    url:str [optional]
         The link to retrieve more detailed information about the entity that uses this catalog dataset.. 
    """
    _converter = t.Dict(
        {
            t.Key("password"):  t.String(),
            t.Key("user"):  t.String(),
            t.Key("catalog_version_id", optional=True):  t.String(),
            t.Key("url", optional=True):  t.String(),
        }
    ).ignore_extra("*")

    def __init__(
        self,
        password,
        user,
        catalog_version_id=None,
        url=None,
    ):
        self.password = password
        self.user = user
        self.catalog_version_id = catalog_version_id
        self.url = url

    def __repr__(self):
        return (
            "PasswordCredentials("
            "password={0.password}, "
            "user={0.user}, "
            "catalog_version_id={0.catalog_version_id}, "
            "url={0.url}, "
        ).format(self)
