#
# Copyright 2021 DataRobot, Inc. and its affiliates.
#
# All rights reserved.
#
# DataRobot, Inc.
#
# This is proprietary source code of DataRobot, Inc. and its
# affiliates.
#
# Released under the terms of DataRobot Tool and Utility Agreement.
"""
Autogenerated DataRobot python client file.  Please don't modify.
"""

import trafaret as t
from datarobot.models.api_object import APIObject

class PatchDataset(APIObject):
    """
    Attributes
    ----------
    categories:bool, date, datetime, dict, float, int, list, str, none_type [optional]
         An array of strings describing the intended use of the dataset. If any categories were previously specified for the dataset, they will be overwritten.. 
    name:str [optional]
         The new name of the dataset.. 
    """
    _converter = t.Dict(
        {
            t.Key("categories", optional=True):  t.Any(),
            t.Key("name", optional=True):  t.String(),
        }
    ).ignore_extra("*")

    def __init__(
        self,
        categories=None,
        name=None,
    ):
        self.categories = categories
        self.name = name

    def __repr__(self):
        return (
            "PatchDataset("
            "categories={0.categories}, "
            "name={0.name}, "
        ).format(self)
