#
# Copyright 2021 DataRobot, Inc. and its affiliates.
#
# All rights reserved.
#
# DataRobot, Inc.
#
# This is proprietary source code of DataRobot, Inc. and its
# affiliates.
#
# Released under the terms of DataRobot Tool and Utility Agreement.
"""
Autogenerated DataRobot python client file.  Please don't modify.
"""

import trafaret as t
from datarobot.models.api_object import APIObject

class PredictJobDetailsResponse(APIObject):
    """
    Attributes
    ----------
    id:str
         the job ID of the job
    is_blocked:bool
         True if a job is waiting for its dependencies to be resolved first.
    message:str
         An optional message about the job
    model_id:str
         The ID of the model
    project_id:str
         the project the job belongs to
    status:str
         the status of the job
    """
    _converter = t.Dict(
        {
            t.Key("id"):  t.String(),
            t.Key("is_blocked"):  t.Bool(),
            t.Key("message"):  t.String(),
            t.Key("model_id"):  t.String(),
            t.Key("project_id"):  t.String(),
            t.Key("status"):  t.String(),
        }
    ).ignore_extra("*")

    def __init__(
        self,
        id,
        is_blocked,
        message,
        model_id,
        project_id,
        status,
    ):
        self.id = id
        self.is_blocked = is_blocked
        self.message = message
        self.model_id = model_id
        self.project_id = project_id
        self.status = status

    def __repr__(self):
        return (
            "PredictJobDetailsResponse("
            "id={0.id}, "
            "is_blocked={0.is_blocked}, "
            "message={0.message}, "
            "model_id={0.model_id}, "
            "project_id={0.project_id}, "
            "status={0.status}, "
        ).format(self)
