#
# Copyright 2021 DataRobot, Inc. and its affiliates.
#
# All rights reserved.
#
# DataRobot, Inc.
#
# This is proprietary source code of DataRobot, Inc. and its
# affiliates.
#
# Released under the terms of DataRobot Tool and Utility Agreement.
"""
Autogenerated DataRobot python client file.  Please don't modify.
"""

import trafaret as t
from datarobot.models.api_object import APIObject

class PredictionExplanationsMetadataValues(APIObject):
    """
    Attributes
    ----------
    shap_remaining_total:int [optional]
         Will be present only if `explanationAlgorithm` = 'shap' and `maxExplanations` is nonzero. The total of SHAP values for features beyond the `maxExplanations`. This can be identically 0 in all rows, if `maxExplanations` is greater than the number of features and thus all features are returned.. 
    """
    _converter = t.Dict(
        {
            t.Key("shap_remaining_total", optional=True):  t.Int(),
        }
    ).ignore_extra("*")

    def __init__(
        self,
        shap_remaining_total=None,
    ):
        self.shap_remaining_total = shap_remaining_total

    def __repr__(self):
        return (
            "PredictionExplanationsMetadataValues("
            "shap_remaining_total={0.shap_remaining_total}, "
        ).format(self)
