#
# Copyright 2021 DataRobot, Inc. and its affiliates.
#
# All rights reserved.
#
# DataRobot, Inc.
#
# This is proprietary source code of DataRobot, Inc. and its
# affiliates.
#
# Released under the terms of DataRobot Tool and Utility Agreement.
"""
Autogenerated DataRobot python client file.  Please don't modify.
"""

import trafaret as t
from datarobot.models.api_object import APIObject

class PredictionValues(APIObject):
    """
    Attributes
    ----------
    label:bool, date, datetime, dict, float, int, list, str, none_type
         In the case of classification, The label of the class.
    value:float
         In the case of classification, the predicted probability of the class identified by the label.
    """
    _converter = t.Dict(
        {
            t.Key("label"):  t.Any(),
            t.Key("value"):  t.Float(),
        }
    ).ignore_extra("*")

    def __init__(
        self,
        label,
        value,
    ):
        self.label = label
        self.value = value

    def __repr__(self):
        return (
            "PredictionValues("
            "label={0.label}, "
            "value={0.value}, "
        ).format(self)
