#
# Copyright 2021 DataRobot, Inc. and its affiliates.
#
# All rights reserved.
#
# DataRobot, Inc.
#
# This is proprietary source code of DataRobot, Inc. and its
# affiliates.
#
# Released under the terms of DataRobot Tool and Utility Agreement.
"""
Autogenerated DataRobot python client file.  Please don't modify.
"""

import trafaret as t
from datarobot.models.api_object import APIObject

class ProjectClone(APIObject):
    """
    Attributes
    ----------
    project_id:str
         The ID of the project to clone.
    project_name:str [optional]
         The name of the project to be created.. 
    """
    _converter = t.Dict(
        {
            t.Key("project_id"):  t.String(),
            t.Key("project_name", optional=True):  t.String(),
        }
    ).ignore_extra("*")

    def __init__(
        self,
        project_id,
        project_name=None,
    ):
        self.project_id = project_id
        self.project_name = project_name

    def __repr__(self):
        return (
            "ProjectClone("
            "project_id={0.project_id}, "
            "project_name={0.project_name}, "
        ).format(self)
