#
# Copyright 2021 DataRobot, Inc. and its affiliates.
#
# All rights reserved.
#
# DataRobot, Inc.
#
# This is proprietary source code of DataRobot, Inc. and its
# affiliates.
#
# Released under the terms of DataRobot Tool and Utility Agreement.
"""
Autogenerated DataRobot python client file.  Please don't modify.
"""

import trafaret as t
from datarobot.models.api_object import APIObject

class RatingTableCreateResponse(APIObject):
    """
    Attributes
    ----------
    rating_table_id:str
         the ID of the newly created rating table
    rating_table_name:str
         The name that was used for the rating table. May differ from the ratingTableName in the request, as names are trimmed and a suffix added to ensure all rating tables derived from the same model have unique names
    """
    _converter = t.Dict(
        {
            t.Key("rating_table_id"):  t.String(),
            t.Key("rating_table_name"):  t.String(),
        }
    ).ignore_extra("*")

    def __init__(
        self,
        rating_table_id,
        rating_table_name,
    ):
        self.rating_table_id = rating_table_id
        self.rating_table_name = rating_table_name

    def __repr__(self):
        return (
            "RatingTableCreateResponse("
            "rating_table_id={0.rating_table_id}, "
            "rating_table_name={0.rating_table_name}, "
        ).format(self)
