#
# Copyright 2021 DataRobot, Inc. and its affiliates.
#
# All rights reserved.
#
# DataRobot, Inc.
#
# This is proprietary source code of DataRobot, Inc. and its
# affiliates.
#
# Released under the terms of DataRobot Tool and Utility Agreement.
"""
Autogenerated DataRobot python client file.  Please don't modify.
"""

import trafaret as t
from datarobot.models.api_object import APIObject
from datarobot.models.full_api.generated.model.rating_table_retrieve_response import RatingTableRetrieveResponse

class RatingTableListResponse(APIObject):
    """
    Attributes
    ----------
    count:int
         the number of RatingTable objects returned
    data:[RatingTableRetrieveResponse]
         the actual records. Each element of the array has the same schema         as if retrieving the table individually from         GET /api/v2/projects/(projectId)/ratingTables/(ratingTableId)/
    next:str, none_type
         URL pointing to the next page (if null, there is no next page)
    previous:str, none_type
         URL pointing to the previous page (if null, there is no previous page)
    """
    _converter = t.Dict(
        {
            t.Key("count"):  t.Int(),
            t.Key("data"):  t.List(t.Dict().allow_extra("*")),
            t.Key("next"):  t.String(),
            t.Key("previous"):  t.String(),
        }
    ).ignore_extra("*")

    def __init__(
        self,
        count,
        data,
        next,
        previous,
    ):
        self.count = count
        self.data = data
        self.next = next
        self.previous = previous

    def __repr__(self):
        return (
            "RatingTableListResponse("
            "count={0.count}, "
            "data={0.data}, "
            "next={0.next}, "
            "previous={0.previous}, "
        ).format(self)
