#
# Copyright 2021 DataRobot, Inc. and its affiliates.
#
# All rights reserved.
#
# DataRobot, Inc.
#
# This is proprietary source code of DataRobot, Inc. and its
# affiliates.
#
# Released under the terms of DataRobot Tool and Utility Agreement.
"""
Autogenerated DataRobot python client file.  Please don't modify.
"""

import trafaret as t
from datarobot.models.api_object import APIObject

class Reasons(APIObject):
    """
    Attributes
    ----------
    supports_image_activation_maps:str [optional]
         If present, the reason image activation maps are not supported for the model.. 
    supports_image_embedding:str [optional]
         If present, the reason image embeddings are not supported for the model.. 
    """
    _converter = t.Dict(
        {
            t.Key("supports_image_activation_maps", optional=True):  t.String(),
            t.Key("supports_image_embedding", optional=True):  t.String(),
        }
    ).ignore_extra("*")

    def __init__(
        self,
        supports_image_activation_maps=None,
        supports_image_embedding=None,
    ):
        self.supports_image_activation_maps = supports_image_activation_maps
        self.supports_image_embedding = supports_image_embedding

    def __repr__(self):
        return (
            "Reasons("
            "supports_image_activation_maps={0.supports_image_activation_maps}, "
            "supports_image_embedding={0.supports_image_embedding}, "
        ).format(self)
