#
# Copyright 2021 DataRobot, Inc. and its affiliates.
#
# All rights reserved.
#
# DataRobot, Inc.
#
# This is proprietary source code of DataRobot, Inc. and its
# affiliates.
#
# Released under the terms of DataRobot Tool and Utility Agreement.
"""
Autogenerated DataRobot python client file.  Please don't modify.
"""

import trafaret as t
from datarobot.models.api_object import APIObject

class RemoteEventData(APIObject):
    """
    Attributes
    ----------
    new_model_id:str [optional]
         The identifier of the model after replacement.. 
    old_model_id:str [optional]
         The identifier of the model before replacement.. 
    reason:str [optional]
         The explanation on why the model has been replaced.. 
    """
    _converter = t.Dict(
        {
            t.Key("new_model_id", optional=True):  t.String(),
            t.Key("old_model_id", optional=True):  t.String(),
            t.Key("reason", optional=True):  t.String(),
        }
    ).ignore_extra("*")

    def __init__(
        self,
        new_model_id=None,
        old_model_id=None,
        reason=None,
    ):
        self.new_model_id = new_model_id
        self.old_model_id = old_model_id
        self.reason = reason

    def __repr__(self):
        return (
            "RemoteEventData("
            "new_model_id={0.new_model_id}, "
            "old_model_id={0.old_model_id}, "
            "reason={0.reason}, "
        ).format(self)
