#
# Copyright 2021 DataRobot, Inc. and its affiliates.
#
# All rights reserved.
#
# DataRobot, Inc.
#
# This is proprietary source code of DataRobot, Inc. and its
# affiliates.
#
# Released under the terms of DataRobot Tool and Utility Agreement.
"""
Autogenerated DataRobot python client file.  Please don't modify.
"""

import trafaret as t
from datarobot.models.api_object import APIObject

class RequestNotification(APIObject):
    """
    Attributes
    ----------
    body:str
         The body of the request
    headers:str
         The headers of the request
    url:str, none_type
         The URL of the request
    """
    _converter = t.Dict(
        {
            t.Key("body"):  t.String(),
            t.Key("headers"):  t.String(),
            t.Key("url"):  t.String(),
        }
    ).ignore_extra("*")

    def __init__(
        self,
        body,
        headers,
        url,
    ):
        self.body = body
        self.headers = headers
        self.url = url

    def __repr__(self):
        return (
            "RequestNotification("
            "body={0.body}, "
            "headers={0.headers}, "
            "url={0.url}, "
        ).format(self)
