#
# Copyright 2021 DataRobot, Inc. and its affiliates.
#
# All rights reserved.
#
# DataRobot, Inc.
#
# This is proprietary source code of DataRobot, Inc. and its
# affiliates.
#
# Released under the terms of DataRobot Tool and Utility Agreement.
"""
Autogenerated DataRobot python client file.  Please don't modify.
"""

import trafaret as t
from datarobot.models.api_object import APIObject

class SecondaryDatasetResponse(APIObject):
    """
    Attributes
    ----------
    catalog_id:str, none_type
         ID of the catalog item.
    catalog_version_id:str
         ID of the catalog version.
    identifier:str
         Short name of this table (used directly as part of generated feature names).
    snapshot_policy:str, none_type
         Policy to be used by a dataset while making prediction.
    required_features:[str] [optional]
         List of required feature names used by the table.. 
    """
    _converter = t.Dict(
        {
            t.Key("catalog_id"):  t.String(),
            t.Key("catalog_version_id"):  t.String(),
            t.Key("identifier"):  t.String(),
            t.Key("snapshot_policy"):  t.String(),
            t.Key("required_features", optional=True):  t.List(t.Dict().allow_extra("*")),
        }
    ).ignore_extra("*")

    def __init__(
        self,
        catalog_id,
        catalog_version_id,
        identifier,
        snapshot_policy,
        required_features=None,
    ):
        self.catalog_id = catalog_id
        self.catalog_version_id = catalog_version_id
        self.identifier = identifier
        self.snapshot_policy = snapshot_policy
        self.required_features = required_features

    def __repr__(self):
        return (
            "SecondaryDatasetResponse("
            "catalog_id={0.catalog_id}, "
            "catalog_version_id={0.catalog_version_id}, "
            "identifier={0.identifier}, "
            "snapshot_policy={0.snapshot_policy}, "
            "required_features={0.required_features}, "
        ).format(self)
