#
# Copyright 2021 DataRobot, Inc. and its affiliates.
#
# All rights reserved.
#
# DataRobot, Inc.
#
# This is proprietary source code of DataRobot, Inc. and its
# affiliates.
#
# Released under the terms of DataRobot Tool and Utility Agreement.
"""
Autogenerated DataRobot python client file.  Please don't modify.
"""

import trafaret as t
from datarobot.models.api_object import APIObject

class ShapWarnings(APIObject):
    """
    Attributes
    ----------
    max_normalized_mismatch:float
         The maximal relative normalized mismatch value.
    mismatch_row_count:int
         The count of rows for which additivity check failed.
    """
    _converter = t.Dict(
        {
            t.Key("max_normalized_mismatch"):  t.Float(),
            t.Key("mismatch_row_count"):  t.Int(),
        }
    ).ignore_extra("*")

    def __init__(
        self,
        max_normalized_mismatch,
        mismatch_row_count,
    ):
        self.max_normalized_mismatch = max_normalized_mismatch
        self.mismatch_row_count = mismatch_row_count

    def __repr__(self):
        return (
            "ShapWarnings("
            "max_normalized_mismatch={0.max_normalized_mismatch}, "
            "mismatch_row_count={0.mismatch_row_count}, "
        ).format(self)
