#
# Copyright 2021 DataRobot, Inc. and its affiliates.
#
# All rights reserved.
#
# DataRobot, Inc.
#
# This is proprietary source code of DataRobot, Inc. and its
# affiliates.
#
# Released under the terms of DataRobot Tool and Utility Agreement.
"""
Autogenerated DataRobot python client file.  Please don't modify.
"""

import trafaret as t
from datarobot.models.api_object import APIObject

class TimeRange(APIObject):
    """
    Attributes
    ----------
    end:datetime, none_type [optional]
         RFC3339 datetime. End of time period to retrieve the features drift for. If not set, defaults to the next top of the hour from now.Note: this field only accepts top of the hour RFC3339 datetime strings For example: ``2019-08-01T00:00:00Z``.. 
    start:datetime, none_type [optional]
         RFC3339 datetime. Start of time period to retrieve the features drift for. If not set, defaults to 1 week from the end of the period.Note: this field only accepts top of the hour RFC3339 datetime strings For example: ``2019-08-01T00:00:00Z``.. 
    """
    _converter = t.Dict(
        {
            t.Key("end", optional=True):  t.DateTime(),
            t.Key("start", optional=True):  t.DateTime(),
        }
    ).ignore_extra("*")

    def __init__(
        self,
        end=None,
        start=None,
    ):
        self.end = end
        self.start = start

    def __repr__(self):
        return (
            "TimeRange("
            "end={0.end}, "
            "start={0.start}, "
        ).format(self)
