#
# Copyright 2021 DataRobot, Inc. and its affiliates.
#
# All rights reserved.
#
# DataRobot, Inc.
#
# This is proprietary source code of DataRobot, Inc. and its
# affiliates.
#
# Released under the terms of DataRobot Tool and Utility Agreement.
"""
Autogenerated DataRobot python client file.  Please don't modify.
"""

import trafaret as t
from datarobot.models.api_object import APIObject
from datarobot.models.full_api.generated.model.use_case_bucket import UseCaseBucket
from datarobot.models.full_api.generated.model.use_case_summary import UseCaseSummary

class UseCaseRealizedValuesOverTimeResponse(APIObject):
    """
    Attributes
    ----------
    buckets:[UseCaseBucket]
         An array of `bucket` objects representing prediction totals and realized value over time
    previous_time_range_summary:UseCaseSummary
        
    summary:UseCaseSummary
        
    """
    _converter = t.Dict(
        {
            t.Key("buckets"):  t.List(t.Dict().allow_extra("*")),
            t.Key("previous_time_range_summary"):  t.Any(),
            t.Key("summary"):  t.Any(),
        }
    ).ignore_extra("*")

    def __init__(
        self,
        buckets,
        previous_time_range_summary,
        summary,
    ):
        self.buckets = buckets
        self.previous_time_range_summary = previous_time_range_summary
        self.summary = summary

    def __repr__(self):
        return (
            "UseCaseRealizedValuesOverTimeResponse("
            "buckets={0.buckets}, "
            "previous_time_range_summary={0.previous_time_range_summary}, "
            "summary={0.summary}, "
        ).format(self)
