#
# Copyright 2021 DataRobot, Inc. and its affiliates.
#
# All rights reserved.
#
# DataRobot, Inc.
#
# This is proprietary source code of DataRobot, Inc. and its
# affiliates.
#
# Released under the terms of DataRobot Tool and Utility Agreement.
"""
Autogenerated DataRobot python client file.  Please don't modify.
"""

import trafaret as t
from datarobot.models.api_object import APIObject

class UseCaseValueTemplateRegressionData(APIObject):
    """
    Attributes
    ----------
    accuracy_improvement:float
         Accuracy improvement
    decisions_count:int
         Estimated number of decisions per year
    target_value:float
         Target value
    """
    _converter = t.Dict(
        {
            t.Key("accuracy_improvement"):  t.Float(),
            t.Key("decisions_count"):  t.Int(),
            t.Key("target_value"):  t.Float(),
        }
    ).ignore_extra("*")

    def __init__(
        self,
        accuracy_improvement,
        decisions_count,
        target_value,
    ):
        self.accuracy_improvement = accuracy_improvement
        self.decisions_count = decisions_count
        self.target_value = target_value

    def __repr__(self):
        return (
            "UseCaseValueTemplateRegressionData("
            "accuracy_improvement={0.accuracy_improvement}, "
            "decisions_count={0.decisions_count}, "
            "target_value={0.target_value}, "
        ).format(self)
