#
# Copyright 2021 DataRobot, Inc. and its affiliates.
#
# All rights reserved.
#
# DataRobot, Inc.
#
# This is proprietary source code of DataRobot, Inc. and its
# affiliates.
#
# Released under the terms of DataRobot Tool and Utility Agreement.
"""
Autogenerated DataRobot python client file.  Please don't modify.
"""

import trafaret as t
from datarobot.models.api_object import APIObject
from datarobot.models.full_api.generated.model.account_limits import AccountLimits
from datarobot.models.full_api.generated.model.rate_limits import RateLimits

class UserLimitsPatchBody(APIObject):
    """
    Attributes
    ----------
    account_limits:AccountLimits [optional]
         
    rate_limits:[RateLimits] [optional]
         The rate limits for the user that are available to be updated. 
    """
    _converter = t.Dict(
        {
            t.Key("account_limits", optional=True):  t.Any(),
            t.Key("rate_limits", optional=True):  t.List(t.Dict().allow_extra("*")),
        }
    ).ignore_extra("*")

    def __init__(
        self,
        account_limits=None,
        rate_limits=None,
    ):
        self.account_limits = account_limits
        self.rate_limits = rate_limits

    def __repr__(self):
        return (
            "UserLimitsPatchBody("
            "account_limits={0.account_limits}, "
            "rate_limits={0.rate_limits}, "
        ).format(self)
