#
# Copyright 2021 DataRobot, Inc. and its affiliates.
#
# All rights reserved.
#
# DataRobot, Inc.
#
# This is proprietary source code of DataRobot, Inc. and its
# affiliates.
#
# Released under the terms of DataRobot Tool and Utility Agreement.
"""
Autogenerated DataRobot python client file.  Please don't modify.
"""

import trafaret as t
from datarobot.models.api_object import APIObject

class UsersPermadeletePreviewStatistics(APIObject):
    """
    Attributes
    ----------
    deployments_will_be_assigned_new_owner:int
         Number of deployments that will be assigned a new owner.
    deployments_will_be_deleted:int
         Number of deployments that will be deleted.
    deployments_will_not_be_deleted:int
         Number of deployments that will not be deleted.
    errors:int
         Number of errors encountered during preview construction.
    projects_will_be_assigned_new_owner:int
         Number of projects that will be assigned a new owner.
    projects_will_be_deleted:int
         Number of projects that will be deleted.
    projects_will_not_be_deleted:int
         Number of projects that will not be deleted.
    users_will_be_deleted:int
         Number of users that will be deleted.
    users_will_not_be_deleted:int
         Number of users that will not be deleted.
    """
    _converter = t.Dict(
        {
            t.Key("deployments_will_be_assigned_new_owner"):  t.Int(),
            t.Key("deployments_will_be_deleted"):  t.Int(),
            t.Key("deployments_will_not_be_deleted"):  t.Int(),
            t.Key("errors"):  t.Int(),
            t.Key("projects_will_be_assigned_new_owner"):  t.Int(),
            t.Key("projects_will_be_deleted"):  t.Int(),
            t.Key("projects_will_not_be_deleted"):  t.Int(),
            t.Key("users_will_be_deleted"):  t.Int(),
            t.Key("users_will_not_be_deleted"):  t.Int(),
        }
    ).ignore_extra("*")

    def __init__(
        self,
        deployments_will_be_assigned_new_owner,
        deployments_will_be_deleted,
        deployments_will_not_be_deleted,
        errors,
        projects_will_be_assigned_new_owner,
        projects_will_be_deleted,
        projects_will_not_be_deleted,
        users_will_be_deleted,
        users_will_not_be_deleted,
    ):
        self.deployments_will_be_assigned_new_owner = deployments_will_be_assigned_new_owner
        self.deployments_will_be_deleted = deployments_will_be_deleted
        self.deployments_will_not_be_deleted = deployments_will_not_be_deleted
        self.errors = errors
        self.projects_will_be_assigned_new_owner = projects_will_be_assigned_new_owner
        self.projects_will_be_deleted = projects_will_be_deleted
        self.projects_will_not_be_deleted = projects_will_not_be_deleted
        self.users_will_be_deleted = users_will_be_deleted
        self.users_will_not_be_deleted = users_will_not_be_deleted

    def __repr__(self):
        return (
            "UsersPermadeletePreviewStatistics("
            "deployments_will_be_assigned_new_owner={0.deployments_will_be_assigned_new_owner}, "
            "deployments_will_be_deleted={0.deployments_will_be_deleted}, "
            "deployments_will_not_be_deleted={0.deployments_will_not_be_deleted}, "
            "errors={0.errors}, "
            "projects_will_be_assigned_new_owner={0.projects_will_be_assigned_new_owner}, "
            "projects_will_be_deleted={0.projects_will_be_deleted}, "
            "projects_will_not_be_deleted={0.projects_will_not_be_deleted}, "
            "users_will_be_deleted={0.users_will_be_deleted}, "
            "users_will_not_be_deleted={0.users_will_not_be_deleted}, "
        ).format(self)
