#
# Copyright 2021 DataRobot, Inc. and its affiliates.
#
# All rights reserved.
#
# DataRobot, Inc.
#
# This is proprietary source code of DataRobot, Inc. and its
# affiliates.
#
# Released under the terms of DataRobot Tool and Utility Agreement.
"""
Autogenerated DataRobot python client file.  Please don't modify.
"""

import trafaret as t
from datarobot.models.api_object import APIObject

class UsersPermadeleteSummaryReportStatistics(APIObject):
    """
    Attributes
    ----------
    deployments_assigned_new_owner:int
         Number of deployments that are assigned a new owner.
    deployments_deleted:int
         Number of deployments that are deleted.
    deployments_not_deleted:int
         Number of deployments that are not deleted.
    errors:int
         Number of errors encountered during users deletion.
    projects_assigned_new_owner:int
         Number of projects that are assigned a new owner.
    projects_deleted:int
         Number of projects that are deleted.
    projects_not_deleted:int
         Number of projects that are not deleted.
    users_deleted:int
         Number of users that are deleted.
    users_not_deleted:int
         Number of users that are not deleted.
    """
    _converter = t.Dict(
        {
            t.Key("deployments_assigned_new_owner"):  t.Int(),
            t.Key("deployments_deleted"):  t.Int(),
            t.Key("deployments_not_deleted"):  t.Int(),
            t.Key("errors"):  t.Int(),
            t.Key("projects_assigned_new_owner"):  t.Int(),
            t.Key("projects_deleted"):  t.Int(),
            t.Key("projects_not_deleted"):  t.Int(),
            t.Key("users_deleted"):  t.Int(),
            t.Key("users_not_deleted"):  t.Int(),
        }
    ).ignore_extra("*")

    def __init__(
        self,
        deployments_assigned_new_owner,
        deployments_deleted,
        deployments_not_deleted,
        errors,
        projects_assigned_new_owner,
        projects_deleted,
        projects_not_deleted,
        users_deleted,
        users_not_deleted,
    ):
        self.deployments_assigned_new_owner = deployments_assigned_new_owner
        self.deployments_deleted = deployments_deleted
        self.deployments_not_deleted = deployments_not_deleted
        self.errors = errors
        self.projects_assigned_new_owner = projects_assigned_new_owner
        self.projects_deleted = projects_deleted
        self.projects_not_deleted = projects_not_deleted
        self.users_deleted = users_deleted
        self.users_not_deleted = users_not_deleted

    def __repr__(self):
        return (
            "UsersPermadeleteSummaryReportStatistics("
            "deployments_assigned_new_owner={0.deployments_assigned_new_owner}, "
            "deployments_deleted={0.deployments_deleted}, "
            "deployments_not_deleted={0.deployments_not_deleted}, "
            "errors={0.errors}, "
            "projects_assigned_new_owner={0.projects_assigned_new_owner}, "
            "projects_deleted={0.projects_deleted}, "
            "projects_not_deleted={0.projects_not_deleted}, "
            "users_deleted={0.users_deleted}, "
            "users_not_deleted={0.users_not_deleted}, "
        ).format(self)
