#
# Copyright 2021 DataRobot, Inc. and its affiliates.
#
# All rights reserved.
#
# DataRobot, Inc.
#
# This is proprietary source code of DataRobot, Inc. and its
# affiliates.
#
# Released under the terms of DataRobot Tool and Utility Agreement.
"""
Autogenerated DataRobot python client file.  Please don't modify.
"""

import trafaret as t
from datarobot.models.api_object import APIObject

class VersionRetrieveResponse(APIObject):
    """
    Attributes
    ----------
    major:int
         The major version number.
    minor:int
         The minor version number.
    version_string:str
         The full version string.
    """
    _converter = t.Dict(
        {
            t.Key("major"):  t.Int(),
            t.Key("minor"):  t.Int(),
            t.Key("version_string"):  t.String(),
        }
    ).ignore_extra("*")

    def __init__(
        self,
        major,
        minor,
        version_string,
    ):
        self.major = major
        self.minor = minor
        self.version_string = version_string

    def __repr__(self):
        return (
            "VersionRetrieveResponse("
            "major={0.major}, "
            "minor={0.minor}, "
            "version_string={0.version_string}, "
        ).format(self)
